﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CRCCsharp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            textBox1.Text = "";
            textBox2.Text = "";
        }
        private bool getCRC(byte[] s, ref byte crcL, ref byte crcH)
        {
            int i, j;
            int current_crc_value;
            byte[] data = new byte[s.Length];
            current_crc_value = 0xFFFF;
            for (i = 0; i <= (s.Length - 1); i++)
            {
                data[i] = s[i];
                current_crc_value = current_crc_value ^ (data[i]);
                for (j = 0; j < 8; j++)
                {
                    if ((current_crc_value & 0x01) != 0)
                        current_crc_value = (current_crc_value >> 1) ^ 0x8408;
                    else
                        current_crc_value = (current_crc_value >> 1);
                }
            }
            crcL = Convert.ToByte(current_crc_value & 0xFF);
            crcH = Convert.ToByte((current_crc_value >> 8) & 0xFF);
            return true;
        }

        private byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            byte[] data=new byte[200];
            string temp = "";
            byte crcL=0, crcH = 0;
            if(textBox1.Text.Length % 2 !=0)
            {
                temp = textBox1.Text + "0";
            }
            else
            {
                temp = textBox1.Text;
            }
            data = HexStringToByteArray(temp);
            getCRC(data,ref crcL,ref crcH);
            temp = Convert.ToString(crcL, 16).PadLeft(2, '0').ToUpper() +" "+ Convert.ToString(crcH, 16).PadLeft(2, '0').ToUpper();
            textBox2.Text = temp;
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }
    }
}
 